'
' Modif By Manuel Candela October 17th, 2003
' ------------------------------------------
' (previous version renamed TinyBuilderDemo.Bas)
'
' RAPIDQ CODE
'
' BUILDS TINY EXECUTABLES FROM BYTECODE
' CmdGuiTest.Exe = RQTINY32.JP + CmdGuiTest.Bc
' and
' CmdConTest.Exe = RQTINYCC.JP + CmdConTest.Bc
'
' USAGE : [Path\]TinyBuilder yourPathFileName.bc [0|1]
'      - second command line argument >0 for GUI applications
'      - YourPathFileName.Exe created in the directory of
'        the .bc file
'
' ==============  TO BE SET BY USER =====================
' SET YOUR RQTINYCC.JP and RQTINY32.JP LIBRARY PATH HERE
Const RQ_LIB_PATH = "C:\Rapid-Q\Libs\"
' =======================================================
'
SetConsoleTitle (Application.ExeName)
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
'showMessage Str$(commandCount)
defstr file$
defint type% = 0

if commandCount = 0  then
  ShowMessage "[Path\]filename[.bc] needed.."
  END
end if

file$ = command$(1)
if Right$( file$, 3 ) = ".bc"  then
else
  file$ = file$ & ".bc"
end if

if fileExists( file$ )  then         'It doesn't accept NOT
else
  ShowMessage file$ & "  not found!!.."
  END
end if

if CommandCount > 1  then
  type% = Val( command$(2) )
end if

' ----- RAPIDQ BC to EXE BUILDER -----
Dim bcFile As QFileStream
Dim jpFile As QFileStream
Dim exeFile As QFileStream
DefStr sBc, sJp, sExe
'----------------------------
' Creates Gui  .Exe
if type% > 0  then
  bcFile.Open (file$, fmOpenRead)
  jpFile.Open (RQ_LIB_PATH & "RQTINY32.JP", fmOpenRead) ' USE RQTINY32.JP for a gui application
  exeFile.Open (Left$(file$, Len(file$)-3)+".Exe", fmCreate)

  sBc = bcFile.ReadBinStr(bcFile.Size)
  sJp = jpFile.ReadBinStr(jpFile.Size)
  exeFile.WriteBinStr (sJp, jpFile.Size)
  exeFile.WriteBinStr (sbc, bcFile.Size)
else
  ' ----------------------------
  ' Creates console .Exe
  bcFile.Open (file$, fmOpenRead)
  jpFile.Open (RQ_LIB_PATH & "RQTINYCC.JP", fmOpenRead) ' USE RQTINTCC.JP for a console application
  exeFile.Open (Left$(file$, Len(file$)-3)+".Exe", fmCreate)

  sBc = bcFile.ReadBinStr(bcFile.Size)
  sJp = jpFile.ReadBinStr(jpFile.Size)
  exeFile.WriteBinStr (sJp, jpFile.Size)
  exeFile.WriteBinStr (sbc, bcFile.Size)
end if

exeFile.Close
jpFile.Close
bcFile.Close
' -------------------------------------------------------------
' WAIT BEFORE EXITING CONSOLE
' ---------------------------
DefStr sExit
'
Input "\n\n" & (File$ - ".bc") & ".Exe    CREATED\n\n       CR to QUIT \n\n", sExit
Application.Terminate
End
'
 